<?php

namespace BSD_Split_Pay_Stripe_Connect_Woo\Inc;

if (!function_exists('BSD_Split_Pay_Stripe_Connect_Woo\Inc\bsd_scsp_activate_plugin')) {
    function bsd_scsp_activate_plugin()
    {
        if (version_compare(get_bloginfo('version'), '5.0', '<')) {
            wp_die(__('You must update WordPress to use this plugin.', 'bsd-split-pay-stripe-connect-woo'));
        }
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        global $wpdb;
        $table_prefix = $wpdb->prefix;
        $table_name = $table_prefix . 'bsd_scsp_transfer_log';
        try {
            
            if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
                // dbDelta( "SET sql_mode = '';" );
                $sql = 'CREATE TABLE ' . $table_name . '(
                        id INT NOT NULL AUTO_INCREMENT
                        , wc_order_id BIGINT UNSIGNED
                        , charge_amount decimal(10,2)
                        , transfer_amount decimal(10,2)
                        , charge_id VARCHAR(50)
                        , charge_date DATETIME
                        , charge_description VARCHAR(200)
                        , transfer_id VARCHAR(50)
                        , transfer_destination VARCHAR(50)
                        , stripe_mode VARCHAR(5)
                        , date_created DATETIME NOT NULL DEFAULT "0000-00-00 00:00:00"
                        , date_modified DATETIME NOT NULL DEFAULT "0000-00-00 00:00:00"
                        , PRIMARY KEY (id)
              ) ENGINE=InnoDB ' .  $wpdb->get_charset_collate() . ';';

                $is_table_created = dbDelta($sql);
            }

        } catch (\Exception $e) {
            error_log('[BSD Split Pay for Stripe Connect on Woo Activation] Error creating database table: ' . $table_name);
            
        }
        
        $charset_collate = $wpdb->get_charset_collate();
        $table_name = $table_prefix . BSD_SCSP_STRP_ACCNT_TABLE;
        try {
			if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
                $sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " (
                        bsd_sat_id bigint(20) NOT NULL AUTO_INCREMENT,
                        bsd_account_id varchar(55) DEFAULT '' NOT NULL,
                        bsd_account_name varchar(55) DEFAULT '' NOT NULL,
                        PRIMARY KEY  (bsd_sat_id)
                    ) $charset_collate;";

                
                
                dbDelta($sql);
            }

        } catch (\Exception $e) {
            error_log('[BSD Split Pay for Stripe Connect on Woo Activation] Error creating database table: ' . $table_name);
        }
    }
}
