var $ = jQuery;
$(document).ready(function () {
    var sync_accounts_btn_html = $("#sync_accounts_btn").clone();
    $("#sync_accounts_btn").remove();
    $(".bsd-scsp-settings .form-table tr:first-child th").html(sync_accounts_btn_html);
    $("#sync_accounts_btn").show();

    var csync_accounts_btn_html = $("#csync_accounts_btn").clone();
    $("#csync_accounts_btn").remove();
    $(".bsd-scsp-settings .form-table tr:first-child th").append(csync_accounts_btn_html);
    $("#csync_accounts_btn").show();

    if ($("#sspscwsca_select").length) {
        $('#sspscwsca_select').select2({
            placeholder: "Select",
            allowClear: true,
            templateResult: formatOptions,
            language: {
                noResults: function () {
                    return 'No Result Found! <button id="no-results-btn">Click to add it</button>';
                },
            },
            escapeMarkup: function (markup) {
                return markup;
            },
            // closeOnSelect: false,
            templateSelection: function(data) {
                if(data.id !== ""){
                    return data.text + " - "+ data.id;
                }
                return data.text;
            }

        }).on('select2-open', function() {

            // however much room you determine you need to prevent jumping
            var requireHeight = 600;
            var viewportBottom = $(window).scrollTop() + $(window).height();
    
            // figure out if we need to make changes
            if (viewportBottom < requireHeight) 
            {           
                // determine how much padding we should add (via marginBottom)
                var marginBottom = requireHeight - viewportBottom;
    
                // adding padding so we can scroll down
                $(".aLwrElmntOrCntntWrppr").css("marginBottom", marginBottom + "px");
    
                // animate to just above the select2, now with plenty of room below
                $('html, body').animate({
                    scrollTop: $("#sspscwsca_select").offset().top - 10
                }, 1000);
            }
        });
        
        $(document).on("click", "#no-results-btn", function(){
            
            var data = {
                action: "add_custom_account",
                account_id: $('.select2-search__field')[0].value
            };
            $.ajax({
                url: bsd_admin_plugin_vars.ajax_url,
                type: "post",
                data: data,
                success: function (response) {}
            });
            var option_html = '<option value="' + $('.select2-search__field')[0].value + '">' + $('.select2-search__field')[0].value + '</option>';
            $("#sspscwsca_select").prepend(option_html);
            $("#sspscwsca_select").val($('.select2-search__field')[0].value).change();
        });
        

    }
    function formatOptions(repo) {


        var $container = $(
            "<div class='select2-result-repository clearfix'>" +
            "<div class='select2-result-repository__meta'>" +
            "<div class='select2-result-repository__title'></div>" +
            "<div class='select2-result-repository__description'></div>" +
            "</div>" +
            "</div>"
        );

        $container.find(".select2-result-repository__title").text(repo.text);
        $container.find(".select2-result-repository__description").text(repo.id);

        return $container;
    }

    
    window.current_page = 2;
    $("#sync_accounts_btn").on("click", function () {
        fetch_account_ajax();
        $("#sync_btn_text").hide();
        $("#sync_accounts_btn .bsd_loader").show();
        $("#sync_accounts_btn").addClass("disabled");

    });

    $("#csync_accounts_btn").on("click", function () {
        clear_accounts_ajax();
        $("#csync_btn_text").hide();
        $("#csync_accounts_btn .bsd_loader").show();
        $("#csync_accounts_btn").addClass("disabled");
        
    });

    $(document).on("click", "#copy_account_id", function() {
        
        var copyText = $('#sspscwsca_select').select2('data')[0].id;
        if(copyText != ""){
            var value= `<input value="${copyText}" id="selVal" />`;
            $(value).insertAfter('#sspscwsca_select');
            $("#selVal").select();
            document.execCommand("Copy");
            $('body').find("#selVal").remove();
        }
    });

    $("#bsd_spscwt_type").on("change", function(){
        var selected_type = $(this).val();
        if(selected_type == "amount"){
            $(".bsd_spscwtp_input").hide();
            // $(".bsd_spscwt_amount").css("display", "table-row");
            $(".bsd_spscwt_amount").show();
            
        }else {
            $(".bsd_spscwt_amount").hide();
            // $(".bsd_spscwtp_input").css("display", "table-row");
            $(".bsd_spscwtp_input").show();
        }
    });

    $("#_bsd_spscwt_product_type").on("change", function(){
        var selected_type = $(this).val();
        if(selected_type == "amount"){
            $(".bsd_scsptp").hide();
            $(".bsd_spscwt_product_amount").show();
            
        }else {
            $(".bsd_spscwt_product_amount").hide();
            $(".bsd_scsptp").show();
        }
    });

    $(document).on("change", "._bsd_spscwt_product_type", function(){
        var selected_type = $(this).val();
        if(selected_type == "amount"){
            $(this).parent().siblings(".bsd_scsptp").hide();
            $(this).parent().siblings(".bsd_spscwt_product_amount").show();
            
        }else {
            $(this).parent().siblings(".bsd_spscwt_product_amount").hide();
            $(this).parent().siblings(".bsd_scsptp").show();
        }
    });

});


function fetch_account_ajax() {
    var data = {
        action: "fetch_accounts",
        page: window.current_page
    };
    $.ajax({
        url: bsd_admin_plugin_vars.ajax_url,
        type: "post",
        data: data,
        success: function (response) {
            if (!response.is_finished) {
                window.current_page = response.current_page;
                if (response.new_account_ids.length > 0) {
                    var option_html = "";
                    var account_name = "";
                    response.new_account_ids.forEach(function (item, index) {
                        if (item.account_name != null) {
                            account_name = item.account_name;
                        } else {
                            account_name = item.account_id;
                        }
                        option_html += '<option value="' + item.account_id + '">' + account_name + '</option>';
                    });
                    $("#sspscwsca_select").append(option_html);
                }
                fetch_account_ajax();
            } else {
                if ("new_account_ids" in response && response.new_account_ids.length > 0) {
                    var option_html = "";
                    var account_name = "";
         
                        response.new_account_ids.forEach(function (item, index) {
                            if (item.account_name != null) {
                                account_name = item.account_name;
                            } else {
                                account_name = item.account_id;
                            }
                            option_html += '<option value="' + item.account_id + '">' + account_name + '</option>';
                        });
                        $("#sspscwsca_select").append(option_html);
                    
                    
                }
                $("#sync_btn_text").show();
                $("#sync_accounts_btn .bsd_loader").hide();
                $("#sync_accounts_btn").removeClass("disabled");
            }

        }
    });
}

function clear_accounts_ajax(){
    var data = {
        action: "clear_accounts",
        page: window.current_page
    };
    $.ajax({
        url: bsd_admin_plugin_vars.ajax_url,
        type: "post",
        data: data,
        success: function (response) {
            $("#csync_btn_text").show();
            $("#csync_accounts_btn .bsd_loader").hide();
            $("#csync_accounts_btn").removeClass("disabled");

            window.location.reload(true);

        }
    });
}