<?php
/**
 * Displays a table in the WC Settings page
 *
 */

$GLOBALS['hide_save_button'] = true;

?>
<div class="wrap">
  <h2>Dashboard</h2>
  <div id="col-container">
    <!-- Content goes here -->
    <?php 

        $wp_stripe_connect = new Bsd_Woocommerce_Stripe_Connect_Split_Pay_Stripe();
        $postMetas = $wp_stripe_connect->stp_retrieve_transfer_info("stripeTransfer");
        
        if (isset($postMetas)) { ?>
          <table id='example-dashboard' class='display' cellspacing='0' width='100%'>
          <thead>
              <tr>
            <th><?php esc_html_e( 'Customer Details' )?></th>
            <th><?php esc_html_e( 'Connected Account' )?></th>
              </tr>
            </thead>
                <tbody>
                      <?php
                      foreach ($postMetas as $value) {
                          $metaData = json_decode($value->meta_value, true); ?>
                          <tr>
                              <td> 
                                  <p><b>order Id: </b> <?php echo esc_attr($metaData['order_id']); ?> </p>
                                  <p><b>Customer Name: </b> <?php echo esc_attr($metaData['custName']); ?> </p>
                                  <p><b>Customer Email: </b><?php echo esc_attr($metaData['custEmail']); ?> </p>
                                  <p><b>Total Amunt Paid: </b>US$ <?php echo number_format(esc_attr($metaData['totalPaid'])/100, 2); ?> </p>
                          </td>
                              <td>
                                  <p><b>Connected Account Id: </b><?php echo esc_attr($metaData['destinationAcc']); ?> </p>
                                  <p><b>Amount Transfered to connected Account (<?php echo get_option("transfer_percentage"); ?>% of Total Amt.): </b>US$ <?php echo number_format(esc_attr($metaData['tranferAmt'])/100, 2); ?> </p>
                                  <p> </p>
                                  <p></p>
                              </td>
                          </tr>
                          <?php
                        } ?>
                      
                      <tfoot>
                      <tr>
                    <th><?php esc_html_e( 'Customer Details' )?></th>
                    <th><?php esc_html_e( 'Connected Account' )?></th>
                      </tr>
                    </tfoot>
                </tbody>
          </table>

          <?php exit;
        } else {
            echo "<h3>Please, congigure your settings first.";
            echo "<br/>";
            echo "Visit the settings Page.";
        }

    ?>          
  </div>
</div>