<?php

/**
 * Main plugin class
 *
 * @package     bspscw
 */
namespace BSD_Split_Pay_Stripe_Connect_Woo\Inc;

use  Exception ;
if ( !defined( 'ABSPATH' ) ) {
    exit( 'Sorry!' );
}
// Exit if accessed directly
if ( !class_exists( 'BSD_Split_Pay_Stripe_Connect_Woo\\Inc\\BSD_SCSP_Main_Plugin' ) ) {
    class BSD_SCSP_Main_Plugin
    {
        public  $log_prefix = '[BSD Split Pay for Stripe Connect on Woo] ' ;
        public function run()
        {
            add_action( 'woocommerce_api_wc_stripe', array( $this, 'check_for_webhook' ), 9 );
            if ( function_exists( 'BSD_Split_Pay_Stripe_Connect_Woo\\bsdwcscsp_fs' ) ) {
            }
            // Add Documentation link to plugin row meta
            add_filter(
                'plugin_row_meta',
                array( $this, 'plugin_row_meta' ),
                10,
                2
            );
            if ( function_exists( 'BSD_Split_Pay_Stripe_Connect_Woo\\bsdwcscsp_fs' ) ) {
            }
            if ( function_exists( 'BSD_Split_Pay_Stripe_Connect_Woo\\bsdwcscsp_fs' ) ) {
            }
            if ( function_exists( 'BSD_Split_Pay_Stripe_Connect_Woo\\bsdwcscsp_fs' ) ) {
            }
            /* if (function_exists('BSD_Split_Pay_Stripe_Connect_Woo\bsdwcscsp_fs')) {
               if (\BSD_Split_Pay_Stripe_Connect_Woo\bsdwcscsp_fs()->can_use_premium_code()) { */
            // variable product fields
            add_action(
                'woocommerce_variation_options_pricing',
                array( $this, 'bsd_variable_product_fields' ),
                10,
                3
            );
            /* }
               } */
            if ( function_exists( 'BSD_Split_Pay_Stripe_Connect_Woo\\bsdwcscsp_fs' ) ) {
                if ( \BSD_Split_Pay_Stripe_Connect_Woo\bsdwcscsp_fs()->can_use_premium_code() ) {
                    // variable product fields
                    add_action(
                        'woocommerce_save_product_variation',
                        array( $this, 'bsd_variable_product_fields_save' ),
                        10,
                        2
                    );
                }
            }
        }
        
        /*
         * Add account link to plugin links
         *
         */
        public function bsd_scsp_plugin_links( $links )
        {
            $plugin_links = array( '<a href="' . admin_url( 'admin.php?page=bsd-split-pay-stripe-connect-woo-account' ) . '">' . __( 'Account', 'bsd-split-pay-stripe-connect-woo' ) . '</a>' );
            return array_merge( $plugin_links, $links );
        }
        
        /*
         * Add Documentation link to plugin row meta
         *
         */
        public function plugin_row_meta( $plugin_meta, $plugin_file )
        {
            
            if ( BSD_SCSP_PLUGIN_BASE_NAME === $plugin_file ) {
                $row_meta = [
                    'docs' => '<a href="https://docs.splitpayplugin.com" aria-label="' . esc_attr( __( 'View Documentation', 'bsd-split-pay-stripe-connect-woo' ) ) . '" target="_blank">' . __( 'Documentation', 'bsd-split-pay-stripe-connect-woo' ) . '</a>',
                ];
                $plugin_meta = array_merge( $plugin_meta, $row_meta );
            }
            
            return $plugin_meta;
        }
        
        /*
         * Add custom tab to Product Data metabox
         *
         */
        public function bsd_product_data_tab( $product_data_tabs )
        {
            global  $post ;
            $product = wc_get_product( $post->ID );
            if ( !$product->is_type( 'simple' ) ) {
                return $product_data_tabs;
            }
            $product_data_tabs['stripe-connect-split-pay-tab'] = array(
                'label'  => __( 'Stripe Connect Split Pay', 'bsd-split-pay-stripe-connect-woo' ),
                'target' => 'stripe_connect_split_pay_product_data',
            );
            return $product_data_tabs;
        }
        
        /*
         * Add fields to the custom data tab
         *
         */
        public function bsd_product_data_fields( $product_data_tabs )
        {
            global  $woocommerce, $post ;
            ?>

            <div id='stripe_connect_split_pay_product_data' class='panel woocommerce_options_panel'>
                <?php 
            $_bsd_spscwt_product_type = get_post_meta( $post->ID, '_bsd_spscwt_product_type', true );
            $_stripe_connect_split_pay_transfer_percentage = get_post_meta( $post->ID, '_stripe_connect_split_pay_transfer_percentage', true );
            $_bsd_spscwt_product_amount = get_post_meta( $post->ID, '_bsd_spscwt_product_amount', true );
            /* $options['percentage'] = __( 'Percentage', 'woocommerce');
               $options['amount'] = __( 'Fixed Amount', 'woocommerce');
               woocommerce_wp_select(
                   array(
                       'id'      => '_bsd_spscwt_product_type',
                       'label'   => __( 'My Select Field', 'woocommerce' ),
                       'options' =>  $options, //this is where I am having trouble
                       'value'   => $value,
                   ) 
               ); */
            ?>
                <p class=" form-field _bsd_spscwt_product_type_field">
                    <label for="_bsd_spscwt_product_type"><?php 
            esc_html_e( 'Product-Specific Transfer', 'bsd-split-pay-stripe-connect-woo' );
            ?></label>
                    <select id="_bsd_spscwt_product_type" name="_bsd_spscwt_product_type" class="select short">
                        <option value=""><?php 
            esc_html_e( 'Select', 'bsd-split-pay-stripe-connect-woo' );
            ?></option>
                        <option value="percentage" <?php 
            echo  ( $_bsd_spscwt_product_type == "percentage" ? "selected='selected'" : "" ) ;
            ?>><?php 
            esc_html_e( 'Percentage', 'bsd-split-pay-stripe-connect-woo' );
            ?></option>
                        <option value="amount" <?php 
            echo  ( $_bsd_spscwt_product_type == "amount" ? "selected='selected'" : "" ) ;
            ?>><?php 
            esc_html_e( 'Fixed Amount', 'bsd-split-pay-stripe-connect-woo' );
            ?></option>
                    </select>
                    <input type="number" class="short bsd_scsptp <?php 
            echo  ( empty($_bsd_spscwt_product_type) || $_bsd_spscwt_product_type == "percentage" ? "" : "bsd_hidden" ) ;
            ?>" name="_stripe_connect_split_pay_transfer_percentage" id="_stripe_connect_split_pay_transfer_percentage" placeholder="" min="0" step="1" value="<?php 
            echo  $_stripe_connect_split_pay_transfer_percentage ;
            ?>">

                    <input type="number" class="short bsd_spscwt_product_amount <?php 
            echo  ( $_bsd_spscwt_product_type == "amount" ? "" : "bsd_hidden" ) ;
            ?>" name="_bsd_spscwt_product_amount" id="_bsd_spscwt_product_amount" placeholder="" min="0" step="1" value="<?php 
            echo  $_bsd_spscwt_product_amount ;
            ?>">
                </p>
                <?php 
            /* woocommerce_wp_text_input(array(
                   'id'                => '_stripe_connect_split_pay_transfer_percentage',
                   'label'             => __('Transfer Percentage', 'bsd-split-pay-stripe-connect-woo'),
                   'desc_tip'          => 'true',
                   'description'       => __('Enter the percentage of the product price to transfer to a Stripe connected account.', 'bsd-split-pay-stripe-connect-woo'),
                   'type'              => 'number',
                   'custom_attributes' => array(
                       'min'   => '0',
                       'step'  => '1',
                   ),
               )); */
            ?>
            </div>
<?php 
        }
        
        /*
         * Save fields of the custom data tab
         *
         */
        public function bsd_product_data_fields_save( $post_id )
        {
            $_bsd_spscwt_product_type = esc_attr( $_POST['_bsd_spscwt_product_type'] ) ?? null;
            $transfer_percentage = esc_attr( $_POST['_stripe_connect_split_pay_transfer_percentage'] ) ?? null;
            $_bsd_spscwt_product_amount = esc_attr( $_POST['_bsd_spscwt_product_amount'] ) ?? null;
            
            if ( empty($_bsd_spscwt_product_type) ) {
                delete_post_meta( $post_id, '_bsd_spscwt_product_type' );
                delete_post_meta( $post_id, '_stripe_connect_split_pay_transfer_percentage' );
                delete_post_meta( $post_id, '_bsd_spscwt_product_amount' );
            } else {
                update_post_meta( $post_id, '_bsd_spscwt_product_type', $_bsd_spscwt_product_type );
            }
            
            
            if ( $transfer_percentage === null ) {
                delete_post_meta( $post_id, '_stripe_connect_split_pay_transfer_percentage' );
            } else {
                update_post_meta( $post_id, '_stripe_connect_split_pay_transfer_percentage', floatval( $transfer_percentage ) );
            }
            
            
            if ( empty($_bsd_spscwt_product_amount) ) {
                delete_post_meta( $post_id, '_bsd_spscwt_product_amount' );
            } else {
                update_post_meta( $post_id, '_bsd_spscwt_product_amount', floatval( $_bsd_spscwt_product_amount ) );
            }
        
        }
        
        /***************************************
         * BEGIN Modified WooCommerce Functions
         ***************************************/
        /**
         * Check incoming requests for Stripe Webhook data and process them.
         * WooCommerce version 4.0.0
         * 
         * @version 2.0.0
         */
        public function check_for_webhook()
        {
            if ( 'POST' !== $_SERVER['REQUEST_METHOD'] || !isset( $_GET['wc-api'] ) || 'wc_stripe' !== $_GET['wc-api'] ) {
                return;
            }
            $wc_stripe_webhook_handler = new \WC_Stripe_Webhook_Handler();
            // BSD Instantiate WC Stripe class
            $request_body = file_get_contents( 'php://input' );
            $request_headers = array_change_key_case( $wc_stripe_webhook_handler->get_request_headers(), CASE_UPPER );
            // New function call:
            
            if ( !$this->webhook_for_this_site( $request_body ) ) {
                status_header( 200 );
                exit;
            }
            
            // Validate it to make sure it is legit.
            
            if ( $this->is_valid_request( $request_headers, $request_body ) ) {
                $wc_stripe_webhook_handler->process_webhook( $request_body );
                $this->transfer_controller( $request_body );
                status_header( 200 );
                exit;
            } else {
                \WC_Stripe_Logger::log( 'Incoming webhook failed validation: ' . print_r( $request_body, true ) );
                status_header( 400 );
                exit;
            }
        
        }
        
        /**
         * Verify the incoming webhook notification to make sure it is legit.
         *
         * @since 4.0.0
         * WooCommerce @version 4.0.0
         * @param string $request_headers The request headers from Stripe.
         * @param string $request_body The request body from Stripe.
         * @return bool
         *
         * @version 1.0.0
         */
        public function is_valid_request( $request_headers = null, $request_body = null )
        {
            if ( null === $request_headers || null === $request_body ) {
                return false;
            }
            if ( !empty($request_headers['USER-AGENT']) && !preg_match( '/Stripe/', $request_headers['USER-AGENT'] ) ) {
                return false;
            }
            
            if ( !empty($this->secret) ) {
                // Check for a valid signature.
                $signature_format = '/^t=(?P<timestamp>\\d+)(?P<signatures>(,v\\d+=[a-z0-9]+){1,2})$/';
                if ( empty($request_headers['STRIPE-SIGNATURE']) || !preg_match( $signature_format, $request_headers['STRIPE-SIGNATURE'], $matches ) ) {
                    return false;
                }
                // Verify the timestamp.
                $timestamp = intval( $matches['timestamp'] );
                
                if ( abs( $timestamp - time() ) > 5 * MINUTE_IN_SECONDS ) {
                    $first_time = abs( $timestamp - time() );
                    $second_time = 5 * MINUTE_IN_SECONDS;
                    return;
                }
                
                // Generate the expected signature.
                $signed_payload = $timestamp . '.' . $request_body;
                $expected_signature = hash_hmac( 'sha256', $signed_payload, $this->secret );
                // Check if the expected signature is present.
                // BSD: For some reason this is failing when multiple sites use the same Stripe Account ID
                // TO DO: Figure out a fix
                /*if ( ! preg_match( '/,v\d+=' . preg_quote( $expected_signature, '/' ) . '/', $matches['signatures'] ) ) {                
                      $expt_sign = '/,v\d+=' . preg_quote( $expected_signature, '/' ) . '/';                
                      return false;
                  }*/
            }
            
            return true;
        }
        
        /***************************************
         * END Modified WooCommerce Functions
         ***************************************/
        private function calculate_transfer_amount( $order_id, $default_percentage, $data_keys )
        {
            $total_transfer_amount = 0;
            $order = wc_get_order( $order_id );
            $order_items = array();
            $ordered_items = $order->get_items();
            foreach ( $ordered_items as $item ) {
                $product = $item->get_product();
                $product_id = $item->get_product_id();
                $product_price = $product->get_price();
                $quantity = $item->get_quantity();
                $product_price = $product_price * $quantity;
                $product_transfer_amount = 0;
                // \WC_Stripe_Logger::log($this->log_prefix . ': product is_type id ' . print_r($product->get_type(), true));
                
                if ( $product->is_type( 'simple' ) ) {
                    $_bsd_spscwt_product_type = get_post_meta( $product_id, '_bsd_spscwt_product_type', true );
                    $product_transfer_percentage = floatval( get_post_meta( $product_id, '_stripe_connect_split_pay_transfer_percentage', true ) );
                    $_bsd_spscwt_product_amount = floatval( get_post_meta( $product_id, '_bsd_spscwt_product_amount', true ) );
                } else {
                    
                    if ( $product->is_type( 'variation' ) ) {
                        $variation_id = $product->get_variation_id();
                        $_bsd_spscwt_product_type = get_post_meta( $variation_id, '_bsd_spscwt_product_type', true );
                        $product_transfer_percentage = floatval( get_post_meta( $variation_id, '_stripe_connect_split_pay_transfer_percentage', true ) );
                        $_bsd_spscwt_product_amount = floatval( get_post_meta( $variation_id, '_bsd_spscwt_product_amount', true ) );
                        \WC_Stripe_Logger::log( $this->log_prefix . ': variable product id ' . print_r( $variation_id, true ) );
                    }
                
                }
                
                if ( !$product_price ) {
                    continue;
                }
                
                if ( empty($_bsd_spscwt_product_type) ) {
                    
                    if ( $data_keys["bsd_spscwt_type"] == "amount" ) {
                        \WC_Stripe_Logger::log( $this->log_prefix . ': global level fixed transfer amount without quantity ' . print_r( $data_keys["bsd_spscwt_amount"], true ) );
                        $product_transfer_amount = floatval( $data_keys["bsd_spscwt_amount"] ) * $quantity;
                        \WC_Stripe_Logger::log( $this->log_prefix . ': global level fixed transfer amount ' . print_r( $product_transfer_amount, true ) );
                    } else {
                        
                        if ( !empty($product_transfer_percentage) ) {
                            $product_transfer_percentage = $product_transfer_percentage / 100;
                            $product_transfer_amount = $product_price * $product_transfer_percentage;
                            \WC_Stripe_Logger::log( $this->log_prefix . ': product level percentage transfer amount ' . print_r( $product_transfer_amount, true ) );
                        } else {
                            $product_transfer_amount = $product_price * $default_percentage;
                            \WC_Stripe_Logger::log( $this->log_prefix . ': global level percentage transfer amount ' . print_r( $product_transfer_amount, true ) );
                        }
                    
                    }
                
                } else {
                    
                    if ( $_bsd_spscwt_product_type == "percentage" ) {
                        
                        if ( $product_transfer_percentage ) {
                            $product_transfer_percentage = $product_transfer_percentage / 100;
                            $product_transfer_amount = $product_price * $product_transfer_percentage;
                            \WC_Stripe_Logger::log( $this->log_prefix . ': product level percentage transfer amount ' . print_r( $product_transfer_amount, true ) );
                        }
                    
                    } else {
                        if ( $_bsd_spscwt_product_type == "amount" ) {
                            
                            if ( $_bsd_spscwt_product_amount ) {
                                $_bsd_spscwt_product_amount = $_bsd_spscwt_product_amount * $quantity;
                                
                                if ( $product_price > $_bsd_spscwt_product_amount ) {
                                    $product_transfer_amount = $_bsd_spscwt_product_amount;
                                    \WC_Stripe_Logger::log( $this->log_prefix . ': product level fixed transfer amount ' . print_r( $product_transfer_amount, true ) );
                                } else {
                                    $product_transfer_amount = $product_price;
                                    \WC_Stripe_Logger::log( $this->log_prefix . ': product level fixed transfer amount exceeds ' . print_r( $product_transfer_amount, true ) );
                                }
                            
                            }
                        
                        }
                    }
                
                }
                
                \WC_Stripe_Logger::log( $this->log_prefix . ': product_price ' . print_r( $product_price, true ) );
                $total_transfer_amount = $total_transfer_amount + $product_transfer_amount;
            }
            \WC_Stripe_Logger::log( $this->log_prefix . ': total_transfer_amount before subtotal ' . print_r( $total_transfer_amount, true ) );
            // $total_transfer_amount = $total_transfer_amount * 100;
            $subtotal = $order->get_subtotal();
            if ( $total_transfer_amount > $subtotal ) {
                $total_transfer_amount = $subtotal;
            }
            \WC_Stripe_Logger::log( $this->log_prefix . ': total_transfer_amount after subtotal ' . print_r( $total_transfer_amount, true ) );
            $bsd_trnsfr_shpng_fees = get_option( 'bsd_trnsfr_shpng_fees' );
            
            if ( !empty($bsd_trnsfr_shpng_fees) && $bsd_trnsfr_shpng_fees == "1" ) {
                $shipping_total = $order->get_shipping_total();
                \WC_Stripe_Logger::log( $this->log_prefix . ': shipping total ' . print_r( $shipping_total, true ) );
                
                if ( $shipping_total ) {
                    $total_transfer_amount = $total_transfer_amount + $shipping_total;
                    \WC_Stripe_Logger::log( $this->log_prefix . ': total_transfer_amount after shipping ' . print_r( $total_transfer_amount, true ) );
                }
            
            }
            
            $total_transfer_amount = bsd_wcsc_get_amount( $total_transfer_amount );
            return $total_transfer_amount;
        }
        
        /**
         * Get event meta data (payment_intent.succeeded)
         */
        private function get_event_meta( $request_body )
        {
            $data = NULL;
            $event = json_decode( $request_body );
            $charge_description = "";
            $total_amount = "";
            $source_charge_id = "";
            $source_transaction = "";
            $wc_order_id = "";
            try {
                if ( $event->object == "event" ) {
                    if ( $event->data->object->id ) {
                        $event = $this->get_payment_intent_object( $event->data->object->id );
                    }
                }
                \WC_Stripe_Logger::log( $this->log_prefix . ': event_data ' . print_r( $event, true ) );
                \WC_Stripe_Logger::log( $this->log_prefix . ': event->charges->data[0]->created ' . print_r( $event->charges->data[0]->created, true ) );
                \WC_Stripe_Logger::log( $this->log_prefix . ': event->data->object->charges->data[0]->created ' . print_r( $event->data->object->charges->data[0]->created, true ) );
                
                if ( $event->object == "payment_intent" ) {
                    $charge_created = $event->created;
                    $charge_created = date( 'Y-m-d H:i:s', $charge_created );
                    
                    if ( $event->amount ) {
                        $order_amount = $event->amount;
                        $order_amount = $order_amount / 100;
                    } else {
                        \WC_Stripe_Logger::log( $this->log_prefix . ': get_event_meta amount not found ' );
                        return NULL;
                    }
                    
                    $charge_description = $event->description;
                    $total_amount = $event->amount;
                    $source_charge_id = $event->latest_charge;
                    $source_transaction = $event->source;
                    $wc_order_id = $event->metadata->order_id;
                } else {
                    
                    if ( $event->charges->data[0]->created ) {
                        $charge_created = $event->charges->data[0]->created;
                        $charge_created = date( 'Y-m-d H:i:s', $charge_created );
                        
                        if ( $event->charges->data[0]->amount ) {
                            $order_amount = $event->charges->data[0]->amount;
                            $order_amount = $order_amount / 100;
                        } else {
                            \WC_Stripe_Logger::log( $this->log_prefix . ': get_event_meta amount not found ' );
                            return NULL;
                        }
                        
                        $charge_description = $event->charges->data[0]->description;
                        $total_amount = $event->amount;
                        $source_charge_id = $event->charges->data[0]->id;
                        $source_transaction = $event->source;
                        $wc_order_id = $event->charges->data[0]->metadata->order_id;
                    } else {
                        
                        if ( $event->data->object->charges->data[0]->created ) {
                            $charge_created = $event->data->object->charges->data[0]->created;
                            $charge_created = date( 'Y-m-d H:i:s', $charge_created );
                            
                            if ( $event->data->object->charges->data[0]->amount ) {
                                $order_amount = $event->data->object->charges->data[0]->amount;
                                $order_amount = $order_amount / 100;
                            } else {
                                \WC_Stripe_Logger::log( $this->log_prefix . ': get_event_meta amount not found ' );
                                return NULL;
                            }
                            
                            $charge_description = $event->data->object->charges->data[0]->description;
                            $total_amount = $event->data->object->amount;
                            $source_charge_id = $event->data->object->charges->data[0]->id;
                            $source_transaction = $event->data->object->source;
                            $wc_order_id = $event->data->object->charges->data[0]->metadata->order_id;
                        } else {
                            \WC_Stripe_Logger::log( $this->log_prefix . ': get_event_meta created not found ' );
                            return NULL;
                        }
                    
                    }
                
                }
                
                
                if ( $event->livemode && $event->livemode == 'true' ) {
                    $stripe_mode = 'live';
                } else {
                    $stripe_mode = 'test';
                }
                
                $data = array(
                    'charge_amount'      => $order_amount,
                    'charge_created'     => $charge_created,
                    'charge_description' => $charge_description,
                    'total_amount'       => $total_amount,
                    'source_charge_id'   => $source_charge_id,
                    'source_transaction' => $source_transaction,
                    'stripe_mode'        => $stripe_mode,
                    'wc_order_id'        => $wc_order_id,
                );
            } catch ( Exception $e ) {
                error_log( "[BSD Split Pay for Stripe Connect on Woo] Exception in get_event_meta: {$e}" );
            }
            return $data;
        }
        
        private function get_payment_intent_object( $id )
        {
            $data_keys = $this->stp_retrieve_keys();
            
            if ( !$data_keys ) {
                $result_message = 'Missing WooCommerce Stripe settings';
                \WC_Stripe_Logger::log( $this->log_prefix . ': keys not found ' . print_r( $result_message, true ) );
                return NULL;
            }
            
            try {
                $stripe_test_mode = $data_keys['stripeInTestMode'] == 'yes';
                
                if ( $stripe_test_mode ) {
                    $stripe = new \Stripe\StripeClient( $data_keys['secretTestKey'] );
                } else {
                    $stripe = new \Stripe\StripeClient( $data_keys['secretLiveKey'] );
                }
                
                return $stripe->paymentIntents->retrieve( $id, [] );
            } catch ( Exception $e ) {
                \WC_Stripe_Logger::log( $this->log_prefix . ': get_payment_intent_object exception ' . print_r( $e, true ) );
            }
        }
        
        /**
         * Gets the Stripe event type
         */
        private function get_event_type( $request_body )
        {
            $request_body = json_decode( $request_body );
            $event_type = ( $request_body->type ? strtolower( $request_body->type ) : NULL );
            return $event_type;
        }
        
        /**
         * Gets the Stripe source ID
         */
        private function get_source_id( $request_body )
        {
            $event_type = $this->get_event_type( $request_body );
            $source_id = NULL;
            if ( !$event_type ) {
                return NULL;
            }
            $request_body = json_decode( $request_body );
            switch ( $event_type ) {
                case 'charge.succeeded':
                    $source_id = ( isset( $request_body->data->object->source->id ) ? $request_body->data->object->source->id : "" );
                    break;
                case 'payment_intent.succeeded':
                    $source_id = ( isset( $request_body->data->object->source ) ? $request_body->data->object->source : "" );
                    
                    if ( empty($source_id) ) {
                        \WC_Stripe_Logger::log( $this->log_prefix . ' payment_method : ' . print_r( $request_body->data->object->payment_method, true ) );
                        $source_id = ( isset( $request_body->data->object->payment_method ) ? $request_body->data->object->payment_method : "" );
                    }
                    
                    break;
                case 'source.chargeable':
                    $source_id = ( isset( $request_body->data->object->id ) ? $request_body->data->object->id : "" );
                    break;
            }
            return $source_id;
        }
        
        /**
         * Get data from the transfer request
         */
        private function get_transfer_meta( $transfer )
        {
            try {
                $data = NULL;
                // Populate variables from objects. If any required value is null, exit
                
                if ( isset( $transfer['amount'] ) && $transfer->amount ) {
                    $transfer_amount = $transfer->amount;
                    $transfer_amount = $transfer_amount / 100;
                } else {
                    return NULL;
                }
                
                
                if ( isset( $transfer['id'] ) && $transfer->id ) {
                    $transfer_id = $transfer->id;
                } else {
                    return NULL;
                }
                
                
                if ( isset( $transfer['destination'] ) && $transfer->destination ) {
                    $transfer_destination = $transfer->destination;
                } else {
                    return NULL;
                }
                
                
                if ( isset( $transfer['source_transaction'] ) && $transfer->source_transaction ) {
                    $transfer_source_transaction = $transfer->source_transaction;
                } else {
                    return NULL;
                }
                
                $data = array(
                    'transfer_amount'             => $transfer_amount,
                    'transfer_id'                 => $transfer_id,
                    'transfer_destination'        => $transfer_destination,
                    'transfer_source_transaction' => $transfer_source_transaction,
                );
                return $data;
            } catch ( Exception $e ) {
                return NULL;
            }
        }
        
        /**
         * Log the transfer request
         */
        private function log_transfer_request( $event, $transfer )
        {
            $event_info = $this->get_event_meta( $event );
            $transfer_info = $this->get_transfer_meta( $transfer );
            if ( !$event_info || !$transfer_info ) {
                return;
            }
            global  $table_prefix ;
            global  $wpdb ;
            // If the transfer isn't related to this charge, exit
            if ( $event_info['source_charge_id'] != $transfer_info['transfer_source_transaction'] ) {
                return;
            }
            $table_prefix = $wpdb->prefix;
            $table = $table_prefix . 'bsd_scsp_transfer_log';
            
            if ( $wpdb->get_var( "SHOW TABLES LIKE '{$table}'" ) == $table ) {
                $data = array(
                    'wc_order_id'          => $event_info['wc_order_id'],
                    'charge_amount'        => $event_info['charge_amount'],
                    'transfer_amount'      => $transfer_info['transfer_amount'],
                    'charge_id'            => $event_info['source_charge_id'],
                    'charge_date'          => $event_info['charge_created'],
                    'charge_description'   => $event_info['charge_description'],
                    'transfer_id'          => $transfer_info['transfer_id'],
                    'transfer_destination' => $transfer_info['transfer_destination'],
                    'stripe_mode'          => $event_info['stripe_mode'],
                );
                $wpdb->insert( $table, $data );
            }
        
        }
        
        /**
         * Retrieve keys and options
         */
        private function stp_retrieve_keys()
        {
            // Get settings from WooCommerce Stripe Gateway plugin
            $data = null;
            $woocommerce_stripe_settings = get_option( 'woocommerce_stripe_settings' );
            if ( !$woocommerce_stripe_settings ) {
                return false;
            }
            $wc_stripe_live_secret_key = ( isset( $woocommerce_stripe_settings['secret_key'] ) ? $woocommerce_stripe_settings['secret_key'] : null );
            $wc_stripe_test_mode = ( isset( $woocommerce_stripe_settings['testmode'] ) ? $woocommerce_stripe_settings['testmode'] : null );
            $wc_stripe_test_secret_key = ( isset( $woocommerce_stripe_settings['test_secret_key'] ) ? $woocommerce_stripe_settings['test_secret_key'] : null );
            // Get our settings and theirs
            $data = array(
                'connectedKey'      => get_option( 'bsd_split_pay_stripe_connect_woo_stripe_connected_account' ),
                'bsd_spscwt_type'   => get_option( 'bsd_spscwt_type' ),
                'percentage'        => get_option( 'bsd_split_pay_stripe_connect_woo_transfer_percentage' ),
                'bsd_spscwt_amount' => get_option( 'bsd_spscwt_amount' ),
                'secretTestKey'     => $wc_stripe_test_secret_key,
                'secretLiveKey'     => $wc_stripe_live_secret_key,
                'stripeInTestMode'  => $wc_stripe_test_mode,
            );
            return $data;
        }
        
        /**
         * Determine whether or not to initiate a transfer
         */
        private function transfer_controller( $request_body )
        {
            require_once dirname( __FILE__ ) . '/vendor/autoload.php';
            $event_type = $this->get_event_type( $request_body );
            
            if ( $event_type == 'payment_intent.succeeded' ) {
                list( $success, $result_message, $transfer ) = $this->transfer_to_account( $request_body );
                
                if ( $success ) {
                    $this->log_transfer_request( $request_body, $transfer );
                } else {
                    // TODO: Notify administrator. For now, error_log it
                    \WC_Stripe_Logger::log( $this->log_prefix . ': ' . print_r( $result_message, true ) );
                }
            
            }
        
        }
        
        /**
         * Transfer to connected account
         */
        private function transfer_to_account( $request_body )
        {
            $result_message = NULL;
            $success = false;
            $transfer = NULL;
            $data_keys = $this->stp_retrieve_keys();
            
            if ( !$data_keys ) {
                $result_message = 'Missing WooCommerce Stripe settings';
                return array( $success, $result_message, $transfer );
            }
            
            $event_data = $this->get_event_meta( $request_body );
            
            if ( $event_data ) {
                try {
                    $stripe_test_mode = $data_keys['stripeInTestMode'] == 'yes';
                    //$exclude_shipping = $data_keys['excludeShipping'] == '1' ? true : false;
                    //$exclude_tax = $data_keys['excludeTax'] == '1' ? true : false;
                    $default_percentage = $data_keys['percentage'] / 100;
                    // Order details
                    $order_id = $event_data['wc_order_id'];
                    $source_transaction = $event_data['source_charge_id'];
                    $total_amount = $event_data['charge_amount'];
                    \WC_Stripe_Logger::log( $this->log_prefix . ': order_id ' . print_r( $order_id, true ) );
                    \WC_Stripe_Logger::log( $this->log_prefix . ': source_transaction ' . print_r( $source_transaction, true ) );
                    
                    if ( !$order_id || !$source_transaction ) {
                        $result_message = 'Missing order data.';
                        return array( $success, $result_message, $transfer );
                    }
                    
                    $transfer_amount = $this->calculate_transfer_amount( $order_id, $default_percentage, $data_keys );
                    
                    if ( !$transfer_amount ) {
                        $result_message = 'Error calculating transfer amount.';
                        return array( $success, $result_message, $transfer );
                    }
                    
                    
                    if ( $stripe_test_mode ) {
                        \Stripe\Stripe::setApiKey( $data_keys['secretTestKey'] );
                    } else {
                        \Stripe\Stripe::setApiKey( $data_keys['secretLiveKey'] );
                    }
                    
                    $woo_currency = get_woocommerce_currency();
                    $currency = ( $woo_currency ? $woo_currency : 'usd' );
                    $transfer = \Stripe\Transfer::create( [
                        'amount'             => $transfer_amount,
                        'currency'           => $currency,
                        'source_transaction' => $source_transaction,
                        'destination'        => $data_keys['connectedKey'],
                    ] );
                    \WC_Stripe_Logger::log( $this->log_prefix . ': transfer ' . print_r( $transfer, true ) );
                    $success = true;
                    $result_message = 'Transfer successful';
                    return array( $success, $result_message, $transfer );
                } catch ( \InvalidRequestException $e ) {
                    // Invalid request
                    $result_message = "Invalid request: {$e}";
                    \WC_Stripe_Logger::log( $this->log_prefix . ': transfer Invalid request' . print_r( $result_message, true ) );
                    return array( $success, $result_message, $transfer );
                } catch ( Exception $e ) {
                    
                    if ( stristr( $e, 'no such destination' ) ) {
                        $account_number = substr( $e, strpos( $e, 'acct_' ) );
                        $account_number = explode( ' ', trim( $account_number ) );
                        $account_number = $account_number[0];
                        $result_message = "Ignored; cannot find account number: {$account_number}. Stripe replied 'No such destination.'";
                        \WC_Stripe_Logger::log( $this->log_prefix . ': ' . print_r( $result_message, true ) );
                        return array( $success, $result_message, $transfer );
                    } else {
                        $result_message = "Exception: {$e}";
                        \WC_Stripe_Logger::log( $this->log_prefix . ': ' . print_r( $result_message, true ) );
                        return array( $success, $result_message, $transfer );
                    }
                
                }
            } else {
                $result_message = 'Could not retreive order meta data.';
                \WC_Stripe_Logger::log( $this->log_prefix . ': ' . print_r( $result_message, true ) );
                return array( $success, $result_message, $transfer );
            }
        
        }
        
        /**
         * Check if the webhook is for this site
         */
        private function webhook_for_this_site( $request_body )
        {
            // Look for source id
            $source_id = $this->get_source_id( $request_body );
            
            if ( empty($source_id) ) {
                \WC_Stripe_Logger::log( $this->log_prefix . ' source_id not found: ' . print_r( $source_id, true ) );
                return false;
            }
            
            \WC_Stripe_Logger::log( $this->log_prefix . ' source_id : ' . print_r( $source_id, true ) );
            // Check with Woo to see if it's a valid order
            $order = \WC_Stripe_Helper::get_order_by_source_id( $source_id );
            // If yes return true
            if ( $order ) {
                return true;
            }
            // If no return false
            return false;
        }
        
        public function bsd_variable_product_fields( $loop, $variation_data, $variation )
        {
            if ( function_exists( 'BSD_Split_Pay_Stripe_Connect_Woo\\bsdwcscsp_fs' ) ) {
                
                if ( \BSD_Split_Pay_Stripe_Connect_Woo\bsdwcscsp_fs()->can_use_premium_code() ) {
                    $_bsd_spscwt_product_type = get_post_meta( $variation->ID, '_bsd_spscwt_product_type', true );
                    $_stripe_connect_split_pay_transfer_percentage = get_post_meta( $variation->ID, '_stripe_connect_split_pay_transfer_percentage', true );
                    $_bsd_spscwt_product_amount = get_post_meta( $variation->ID, '_bsd_spscwt_product_amount', true );
                    ?>
                            <p class="form-field form-row form-row-first">
                                <label><?php 
                    esc_html_e( 'Variable Product-Specific Transfer', 'bsd-split-pay-stripe-connect-woo' );
                    ?></label>
                                <select name="_bsd_spscwt_product_type[<?php 
                    echo  $variation->ID ;
                    ?>]" id="_bsd_spscwt_product_type[<?php 
                    echo  $variation->ID ;
                    ?>]" class="postform _bsd_spscwt_product_type">
                                <option value=""><?php 
                    esc_html_e( 'Select', 'bsd-split-pay-stripe-connect-woo' );
                    ?></option>
                                    <option value="percentage" <?php 
                    echo  ( $_bsd_spscwt_product_type == "percentage" ? "selected='selected'" : "" ) ;
                    ?>><?php 
                    esc_html_e( 'Percentage', 'bsd-split-pay-stripe-connect-woo' );
                    ?></option>
                                    <option value="amount" <?php 
                    echo  ( $_bsd_spscwt_product_type == "amount" ? "selected='selected'" : "" ) ;
                    ?>><?php 
                    esc_html_e( 'Fixed Amount', 'bsd-split-pay-stripe-connect-woo' );
                    ?></option>
                                </select>
                            </p>
                            <p class="form-field form-row form-row-last bsd_scsptp <?php 
                    echo  ( empty($_bsd_spscwt_product_type) || $_bsd_spscwt_product_type == "percentage" ? "" : "bsd_hidden" ) ;
                    ?>"> 
                                <label for="_stripe_connect_split_pay_transfer_percentage[<?php 
                    echo  $variation->ID ;
                    ?>]"><?php 
                    esc_html_e( 'Percentage', 'bsd-split-pay-stripe-connect-woo' );
                    ?></label>
                                <input type="number" class="short wc_input_price " name="_stripe_connect_split_pay_transfer_percentage[<?php 
                    echo  $variation->ID ;
                    ?>]" id="_stripe_connect_split_pay_transfer_percentage[<?php 
                    echo  $variation->ID ;
                    ?>]" value="<?php 
                    echo  $_stripe_connect_split_pay_transfer_percentage ;
                    ?>" min="0" step="1">
                            </p>
            
                            <p class="form-field form-row form-row-last bsd_spscwt_product_amount <?php 
                    echo  ( $_bsd_spscwt_product_type == "amount" ? "" : "bsd_hidden" ) ;
                    ?>">
                                <label for="_bsd_spscwt_product_amount[<?php 
                    echo  $variation->ID ;
                    ?>]"><?php 
                    esc_html_e( 'Fixed amount', 'bsd-split-pay-stripe-connect-woo' );
                    ?></label> 
                                <input type="number" class="short wc_input_price " name="_bsd_spscwt_product_amount[<?php 
                    echo  $variation->ID ;
                    ?>]" id="_bsd_spscwt_product_amount[<?php 
                    echo  $variation->ID ;
                    ?>]" value="<?php 
                    echo  $_bsd_spscwt_product_amount ;
                    ?>" min="0" step="1">
                            </p>
                        <?php 
                } else {
                    $image_path = BSD_SCSP_PLUGIN_ASSETS . '/variation-pro-features.png';
                    $upgrade_url = '?billing_cycle=annual&page=bsd-split-pay-stripe-connect-woo-pricing';
                    if ( function_exists( 'bsdwcscsp_fs' ) ) {
                        $upgrade_url = bsdwcscsp_fs()->get_upgrade_url();
                    }
                    ?>
                            
                            <div class="variation_upgrade_wrapper">
                                <?php 
                    echo  esc_html__( 'For variable product split transfers, please', 'bsd-split-pay-stripe-connect-woo' ) ;
                    ?>
                                <a href="<?php 
                    echo  esc_url( $upgrade_url ) ;
                    ?>"><?php 
                    echo  esc_html__( ' Upgrade >', 'bsd-split-pay-stripe-connect-woo' ) ;
                    ?></a>.
                                <br/>
                                <img src="<?php 
                    echo  esc_attr( $image_path ) ;
                    ?>" alt="Blurred example of Stripe Connect transfer" style="width:100%">
                            </div>
                        <?php 
                }
            
            }
        }
        
        public function bsd_variable_product_fields_save( $variation_id, $i )
        {
            $custom_field = $_POST['custom_field'][$variation_id];
            if ( isset( $custom_field ) ) {
                update_post_meta( $variation_id, 'custom_field', esc_attr( $custom_field ) );
            }
            $_bsd_spscwt_product_type = esc_attr( $_POST['_bsd_spscwt_product_type'][$variation_id] ) ?? null;
            $transfer_percentage = esc_attr( $_POST['_stripe_connect_split_pay_transfer_percentage'][$variation_id] ) ?? null;
            $_bsd_spscwt_product_amount = esc_attr( $_POST['_bsd_spscwt_product_amount'][$variation_id] ) ?? null;
            
            if ( empty($_bsd_spscwt_product_type) ) {
                delete_post_meta( $variation_id, '_bsd_spscwt_product_type' );
                delete_post_meta( $variation_id, '_stripe_connect_split_pay_transfer_percentage' );
                delete_post_meta( $variation_id, '_bsd_spscwt_product_amount' );
            } else {
                update_post_meta( $variation_id, '_bsd_spscwt_product_type', $_bsd_spscwt_product_type );
            }
            
            
            if ( $transfer_percentage === null ) {
                delete_post_meta( $variation_id, '_stripe_connect_split_pay_transfer_percentage' );
            } else {
                update_post_meta( $variation_id, '_stripe_connect_split_pay_transfer_percentage', floatval( $transfer_percentage ) );
            }
            
            
            if ( empty($_bsd_spscwt_product_amount) ) {
                delete_post_meta( $variation_id, '_bsd_spscwt_product_amount' );
            } else {
                update_post_meta( $variation_id, '_bsd_spscwt_product_amount', floatval( $_bsd_spscwt_product_amount ) );
            }
        
        }
    
    }
}
// class_exists check
function bsd_wcsc_get_amount( $total, $currency = '' )
{
    $zero_decimals = array(
        'BIF',
        'CLP',
        'DJF',
        'GNF',
        'JPY',
        'KMF',
        'KRW',
        'MGA',
        'PYG',
        'RWF',
        'VND',
        'VUV',
        'XAF',
        'XOF',
        'XPF'
    );
    if ( empty($currency) ) {
        $currency = get_woocommerce_currency();
    }
    $currency = strtoupper( $currency );
    if ( !in_array( $currency, $zero_decimals ) ) {
        $total *= 100;
    }
    return round( $total );
}
